/*RSBAC global network client
 *
 *(c) Stanislav Ievlev <inger@linux.ru.net>
 */
 
/*r-job.c - jobs client. Special edition for cron*/

#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <fcntl.h>
#include <netdb.h>
#include <string.h>

#include "r-job.h"
#include "r-job-lib.h"
#include "auth.h"


char keyword[MAX_LINE]; /*connection keyword*/
char session_keyword[MAX_LINE]; /*session keyword*/





/*main work*/
int main(int argc, char *argv[])
{
    int ch;
    int s;	/*connection socket*/    
    char command_str[MAX_LINE];
    char *hostname=NULL;
    int user_uid=getuid();

/*check args*/
    while ((ch = getopt(argc, argv, "h:u:")) != EOF)
	switch((char)ch)
	    {
		case 'u':		/* Local User */
		    user_uid = strtol(optarg,0,0);
		    break;
		case 'h':           /*Host for connection*/
		    hostname=optarg;
		    break;
	}
	
/*analize options*/
    if (hostname == NULL) {
	hostname=malloc(MAX_LINE);
	strncpy(hostname,DEFAULT_HOST,MAX_LINE);
	}
/*get keyword*/
    get_keyword(keyword,1);    
    
#ifdef TEST
printf("
Options:
hostname:=%s=
user:=%u=
password:=%s=\n",
hostname,user_uid,keyword);
#endif

/*set UID*/
    setuid(user_uid);

/*make command_str*/
    strncpy(command_str,GET_ONLY_COMMAND,MAX_LINE); /*We don't run any command*/
    
    s=client_connection(hostname);
/*send password*/
    client_check_keyword(s,keyword,session_keyword);
/*send command to server*/
    client_write_command(s,command_str);
/*we don't need send job to server*/

/*receive and execute commands from server*/
    client_read_message(s,session_keyword,1,0);

/*close connection*/
    close(s);


    
    return (0);
}