/*RSBAC global network
 *
 *(c) Stanislav Ievlev <inger@linux.ru.net>
 */
 
/*rsa.h - RSA library definitions*/

#include <gmp.h>
#ifndef RSA_H
#define RSA_H
void certificate_name(char *filename,char *station,char *type);
void get_random_prime(mpz_t big,int num);
void Euclid(mpz_t a,mpz_t m,mpz_t b,mpz_t n);
void gen_keys(mpz_t d,mpz_t e,mpz_t n);
void gen_certificates(char *station);

void RSA_Public_encrypt(char *station,char *message);
void RSA_Private_decrypt(char *station,char *message);

void client_accept_station(int s,char *station);
void server_accept_station(int s,char *station);
void client_test(int s,char *station);
int server_test(int s,char *station);

void client_check_cert();    
#endif
